;***** Phasenan/abschnitt ****************************************************
;**
;** Ersteller: U.Hempel 	eMail: heausc@aol.com
;** frei fr alle, die es nutzen wollen
;** keine Garantie auf Fehler 
;** erstellt: 9/2002 
;** Kontroller AT90S1200 mit 4 MHz Quarz
;** 68 Worte 
;**
;** An PD2 ist ein Optokoppler der INT0 auslst (aller 10 ms im Nulldurchgang)
;** bei INT0 werden sin0 Verz.+ w_ist neu gesetzt und die Tasten verz.getestet
;** in der "counter"-ISR werden die Zndverzgerungszeiten runtergezhlt
;** und zwar aller 39,21s (10ms/255) das sind ~0,7Auflsung
;**
;** max.60 Takte werden momentan fr die ISR's bentigt was die Wahl des 
;** Quarzes auf min. 39,21/60=653,5ns=1,53MHz begrenzt. 
;** Das Maximum darf ohne Vorteiler fr den Timer(TCCR0=1)bei, 
;** 39,21s/255(TCNT0)=153,78ns=~6,5MHz, liegen. 4MHz sind also ideal.
;** Der Vorteiler wird mit Eingabe der Quarzfreqenz (in Hz) 
;** bei ".equ	quarz = ?????" richtig berechnet. 
;**
;** Der Anschnittwinkel ist mit den Tasten"+"(PD0) und "-"(PD1) verstellbar.
;** inc/dec  erfolgt im 50ms Takt. Anpassung ber ".equ	tastver	="
;** Mit PD3 ist das Speichern des Wertes im EEProm(Adr.$00)mglich.
;** Ist der Wert schon vorhanden wird nicht gespeichert. 
;** Die Tasten sind alle gegen Masse geschaltet (Pull Up)
;**
;** Der Ausgang des OK an PD2 schaltet gegen Masse. Der Eingang wird mit 100Hz 
;** eines Zweiweggleichrichters gespeist der die selbe Phase wie das
;** Lastrelais hat.PC817 o.. ist recht gut geeignet.Mann kann natrlich auch
;** einen npn Transistor benutzen, beachte aber das Diodenverhalten der 
;** BC-Strecke im Fehlerfall.
;** Das Lastrel. darf keinen Nullspannungsschalter haben.
;** Geeignete Lastrel.sind zB.:S202SE1(8A);S201S01(1,5A);S202T01(2A)
;** Auch der Optokoppler MOC3020 (0,1A)ist geeignet (Conrad????)
;** Angesteuert werden sie ber PD5 gegen +5V ber einen Widerstand entspr.
;** dem LED-Strom.
;** Der Anschnitt erfolgt im Vollwellenbetrieb bei 0-180 und 180-360 mit
;** der gleichen "Zndverzgerung".
;**
;** Das vorzeitige Auslsen des Int0 wird durch eine weitere Verzgerung
;** namens "t_sin0" ausgeglichen. Sie entsteht durch die Flusspannung von OK
;** und Netzteilgleichrichter wobei die Geschichte sehr Bauteilabhngig ist.
;** Ob die Zeit richtig ist stellt mann am Ausgang PD5 fest.
;** Bei max.Verz.(255)darf gerade kein Zndimpuls erscheinen.(OSZI)
;** Bei Wert-1 muss er aber da sein, sonst wird Zndwinkel verschenkt. 
;** Phasenabschnitt ist ebenfalls mglich. Es ist ja egal ob zum Zeitpunkt X
;** die Last zu oder abgeschaltet wird. Ein Triac ist dazu aber nicht nutzbar. 
;** 
;** Ich mchte auch darauf hinweisen das unbedingt eine Entsttung erfolgen
;** muss. Ein ordentliches Netzfilter und keine langen Leitungen zum 
;** Verbraucher sind aber schon recht wirksam.
;**
;****************************************************************************

;** Prozessor def.
.include "1200def.inc"		;Definitionen einfgen

;**** Wertvorgaben **********************************************************
.equ	quarz	=4000000	;Quarzfrequenz in Hz
.equ	teiler	=(quarz*10/25500+5)/10 ;Teiler richtig runden
.equ	t_wert	=$00-teiler	;157=4MHz =>10ms(Timerwert)
.equ	t_sin0	=10		;ca.400s von Sign.OK bis echt sin 0 Durchg.
.equ	tastver	=5		;5x10ms=50ms Tastverzgerung
;****************************************************************************

;***** Register Variablen ***************************************************

.def	Exor	=r1		;Register fr Exor fr Eingnge (1->0,0->1)
.def	temp	=r16
.def	isrtmp	=r17		;Sicherungsregister fr SREG in ISR's
.def	eetmp	=r18		;Reg. fr Epromtest(alter/neuer Wert)
.def	sin0	=r19		;Zhlreg.bis sin0
.def	timer	=r20		;Reg.mit Wert zum Timer setzen()
.def	taste	=r21		;Tastverzgerung (Zhlregister)
.def	w_soll	=r22		;Sollwert Zndwinkel
.def	w_ist	=r23		;Istwert Zndwinkel

;****************************************************************************

;***** Code *****************************************************************

	.cseg
	.org	0x00

	rjmp	reset		;Interruptadressen (reset)
	rjmp	opto		;INT0
	rjmp	counter		;TOV (Timerberlauf ff->00)

;****** Init ****************************************************************
reset:	ldi	temp,$3		;$3 nach temp(r16)
	out	mcucr,temp	;INT0 bei steigender Flanke
	out	timsk,temp	;Timer Interrupt freigeben(Timer steht noch!!)
	ldi	temp,0
	out	EEAR,temp	;EEProm Addresse =$00(man knnte es weglassen)
	sbi	EECR,EERE	;EEPROM Read setzen
EERead:	sbic	EECR,EERE	;wenn EEWE 0 Daten gelesen
	rjmp	EERead		;noch nicht gelesen
	in	w_soll,EEDR	;hole Daten-> w_soll(r30)
	ldi	temp,0b1111111	;PortD-Eingnge mit Pull up
	out	portd,temp	;PD5 wird Ausgang, mit 1 vorbesetzen
	sbi	DDRD,5		;PD5 = Ausgang
	ldi	temp,0b1011011	;ohne PD2(INT0)und PD5(Ausgang)
	mov	exor,temp	;Zum drehen der Eigangssign.an PortD (1->0)
zeitok:	ldi	temp,$40	;
	out	GIMSK,temp	;INT0 freigeben
	sei			;int global ein
	ldi	timer,t_wert	;Timerwert laden
	out	tcnt0,timer	;Timer einstellen
	ldi	temp,1
	out	tccr0,temp	;Timer einschalten

;****** HP ******************************************************************
loop:	brts	ee_wr		;wenn T-Flag gesetzt->ee_wr
	rjmp	loop		;sonst Schleife bis Interrupt

;****** EEProm schreiben ****************************************************
ee_wr:	in	eetmp,eedr	;alte eeprom Daten laden
	cp	eetmp,w_soll	;mit neuen vergleichen
	breq	wr_e		;wenn gleich nicht speichern
ee1:	sbic	eecr,1		;berspringe wenn eewe = 0 (schreiben bereit)
	rjmp	ee1		;noch nicht bereit
	out	eedr,w_soll	;nun in's ee-Datenreg.schreiben
	sbi	eecr,1		;und schreiben aktivieren
wr_e:	clt			;T-Flag lschen
	rjmp	loop

;******* INT0 Bearbeitung ***************************************************
opto:	in	isrtmp,SREG	;SREG sichern
	sbi	portd,5		;Pd5=1 (Rel.aus)
	ldi	sin0,t_sin0	;Wartezeit bis Sin.wirklich null,laden
	mov	w_ist,w_soll	;Zndverz.Sollwert laden
	in	temp,pind	;Portd lesen
	andi	temp,0b1011011	;INT0(PD2) und Ausgang(PD5)lschen
	eor	temp,exor	;Eingangs 1sen in Nullen ndern
	breq	T_end		;wenn alles 0 ->T-end
	dec	taste		;sonst Taste  - 1(Prellzeit-1)
	brne	ende		;wenn nicht 0 ->ende (Prellzeit=0????)
	sbrc	temp,0		;nicht Plustaste (PD0)
	inc	w_soll		;sonst Sollwert+1
	sbrc	temp,1		;nicht Minustaste (PD1)
	dec	w_soll		;sonst Sollwert-1
	sbrc	temp,3		;nicht Speichertaste (PD3)
	ori	isrtmp,$40	;T-Flag fr speichern setzen
T_end:	ldi	taste,tastver	;volle Tastzeit laden
ende:	out	sreg,isrtmp	;SREG zurckschreiben
	reti			;Interrupt ende
				;32Takte max (mit ISR IN/OUT)
;******* Counter Bearbeitung ************************************************
counter:out	tcnt0,timer	;timer neu laden
	in	isrtmp,SREG	;SREG sichern
	tst	sin0		;teste ob Verz.bis sin0 abgelaufen
	breq	Winkel		;wenn ja Zndwinkel bearbeiten
	dec	sin0
	breq	Winkel		;wenn jetzt 0 Zndwinkel bearbeiten
	rjmp 	ZWe		;sonst ->ZWe
Winkel:	tst	w_ist		;teste w_ist auf 0
	breq	ein		;wenn 0 ->ein
	dec	w_ist		;sonst -1
	brne	ZWe		;wenn nicht 0 ->ZWe		
ein:	cbi	portd,5		;Pd5=0 (Rel.ein)
ZWe:	out	sreg,isrtmp	;SREG zurckschreiben
	reti			;28Takte max (mitIN/OUT-ISR)

